#include <windows.h>
#include <process.h>
#include <conio.h>
#include "stdio.h"
#include "KeTCP_Client.h"

DWORD WINAPI ThreadRoutine( LPVOID pParams );
void ParseData( char* pBuf );

#define MODULE_PASSWORD "Jerome"
unsigned char bPasswordOk = false;

//****************************************************************
int main()
{
  KeTCP_Client KeTcp;
  KeTcp.SetConnectionParams( "192.168.0.101", 2424 );

   
  if( !KeTcp.Reconnect() )
	{
		printf( "ERROR: Can't conect to remote host!\r\n" );
    return 0;
	}
  else
  {
    printf( "Connected OK!\r\n" );
  }


  HANDLE hThread;
  DWORD dwThreadId;

  // Starting new thread for reading data from module
  hThread = CreateThread( NULL, 0, ThreadRoutine, (void*)(&KeTcp), 0, &dwThreadId );
  if( hThread == NULL )
  {
    printf( "ERROR: Can't create thread!\r\n" );
    return 0;
  }


  char buf[64];
  unsigned char len = 0;
    
  // Check the connection
  len = sprintf( buf, "$KE\r\n$KE\r\n" );  
  KeTcp.Send( buf, len );  

  // Entering password
  len = sprintf( buf, "$KE,PSW,SET,%s\r\n", MODULE_PASSWORD );  
  KeTcp.Send( buf, len );  

  // Waiting for 1 sec for password readiness
  Sleep( 1000 );

  if( bPasswordOk != true )
  {
    printf( "ERROR: Bad Password\r\n" );
    return 0;
  }
 
  // Start raw data outputting
  len = sprintf( buf, "$KE,DAT,ON\r\n");  
  KeTcp.Send( buf, len );  

  printf( "Press any key to exit...\r\n" ); 
  getch();

  
  KeTcp.Disconnect(); 

  return 0;
}

//****************************************************************
DWORD WINAPI ThreadRoutine( LPVOID pParams )
{
  KeTCP_Client* pKeTcp = (KeTCP_Client*)pParams;
  unsigned int i = 0;
  unsigned int uiSysTime = 0;

  // Data for storing replays from TCP
  #define BUF_SIZE 128
  char Buffer[BUF_SIZE];
  unsigned char offset = 0;
  char cLastChar;
  char ch;


  // Open file for saving output
  FILE* fl = fopen("KeOutput.txt", "wb");
  if( !fl )
  {
    printf( "ERROR: Can't create FILE!\r\n" );
    return 0;
  }

  char buf[256];
  while( pKeTcp->IsConnected() )
  {
    unsigned int len = pKeTcp->Recv( buf, 256 );
    // Save all the output from module into file
    if( len > 0 ) fwrite( buf, len, 1, fl );
    
    // Parsing....
    for( i = 0; i < len; i++ )
    {
	    // protect from memory overflow
	    if( offset >= BUF_SIZE ) offset = 0;	      
          
      ch = buf[i]; 
      Buffer[offset++] = ch;
  
      if( (ch == 0x0A) && (cLastChar == 0x0D) )
      {
        // End of replay has been found			  
        ParseData( Buffer ); 
        offset = 0;               
      }  
      // Save last char
      cLastChar = ch;
    }
  }

  fclose( fl );
  
  return 0;
}

//****************************************************************
void ParseData( char* pBuf )
{
  if( !pBuf || *pBuf != '#' ) return;  
  pBuf++;

  // PSW command group
  if( memcmp(pBuf, "PSW,", 4) == 0 )  
  {
    pBuf += 4;
    if( memcmp(pBuf, "SET,OK", 6) == 0 )  
    {
      // Filter: #PSW,SET,OK
      // Global variable
      bPasswordOk = true; 
      printf( "Password OK!\r\n" );
    }
    else if( memcmp(pBuf, "SET,BAD", 7) == 0 )  
    {
      // Filter: #PSW,SET,BAD
      printf( "WARNING: Wrong Password!\r\n" );
    }	  
	}
  else if( memcmp(pBuf, "ERR", 3) == 0 )  
  {
    // Filter: #ERR
    printf( "WARNING: Syntax error!\r\n" );
  }
  else if( memcmp(pBuf, "TIME,", 5) == 0 )  
  {
    // Filter: #TIME,<SysTime>
    pBuf += 5;
    unsigned int uiSysTime = atoi( pBuf ); 

    printf( "System Time: %d sec\r\n", uiSysTime );
  }
}


//****************************************************************
//****************************************************************